\ ----------------finn kvalitet-----------------------
\ A{{ og ein syntetisk B{ dannar kvalitetslikningar
\ Løysing av desse er vektskoeffisientar som blir brukte til
\ å rekna kvalitet på obs og koo 

: 0hside ( -- )   etal @ 0 DO   0 B{ I } !   LOOP ;

\ skalering av kvalitets-likningane. Trengst for å få vektskoeffisientane
\ som heiltal over 1. Må nedskalerast i utskrift ved kommaflytting
100 CONSTANT KvSkalering	\ jfr 2 places i .punktkvalitet

: KvHside	( e -- )  \ hside=1 skalert med kvskalering
	0hside   				\ nullstilt
	KvSkalering 			\ Q som heiltal
	+skaler  +skaler
	B{ ROT } ! ;

: KvLikningar   ( e -- )
	HentKopiV  		\ still opp venstreside, normallikningane
	KvHside			\ still opp høgreside, syntetisk
	etal @ gauss ;

VARIABLE M0		\ observasjonsmiddelfeil ( på vekt =1 )

\ 2 har plass for 1D og 2D
2 INTEGER ARRAY Q{	\ mellomlagring av vektskoeff
2 INTEGER ARRAY M{	\ mellomlagring av koo-middelfel

: elementkvalitet ( e - Q )			\ nøyaktighet på eitt element
      DUP   KvLikningar ( e )
      X{ SWAP } @  ; ( Q )               \ oppskalert med kvskal

: mq ( Q' -- me ) \ m på element, i rekneeining
	isqrt KvSkalering isqrt ( Q'' 10 )
	m0 @ swap */ ;

: elementkvalitet! ( e i -- )
	>R
	elementkvalitet dup mq    ( Q M )
	M{ R@ } !   Q{ R> } ! ;
	
: punktkvalitet ( pnr -- ) \      startklokke
	2 0 DO
		DUP elementnr2 swap ( ey ex )
		I PICK >R  DROP DROP
		R>  i elementkvalitet!     
	LOOP DROP \                    stoppklokke 
	;
\ -----------------------------------------------
: ?.gon ( n -- ) ?DUP IF  .gon  ELSE  10 -.R  THEN ;
: ?.m ( n -- ) ?DUP IF  meterkomma 10 X.R  ELSE  10 -.R   THEN ;
: ?.hvgon ( hv p -- )  IF  .gon  ELSE  10 -.R   THEN ;

: .punktkvalitet ( Qy My Qx Mx - )
	2 places \ jfr KvSkalering. Nedskalering i utskrift
	2 0 DO   Q{ I } @ 7 X.R   LOOP
	2 0 DO   M{ I } @ meterkomma 7 X.R   LOOP ;  \  for koo

 : .pkt+kvalitet ( - )        \ elem-feil
    CR CR 
	.overskriftXY ."      nr   Qxx     Qyy     Mx      My" 
    AllePkt DO  
		i .pxy
       NYPNR{ I } @ IF
          NYPNR{ I } @ 4 .R
          I  punktkvalitet .punktkvalitet
       THEN
    LOOP ;

: forventning ( vekt -- feil ) \ jfr definisjon av vekt
	vektskonstant @  swap / isqrt ;
	
: .restLS ( snr )
	cr  32 spaces  meterkomma
	LS{ over } @    10  X.R
	dup LengdeKonst     4 SPACES ( f ) 8 X.R  
	LSvekt{ swap } @
        DUP IF forventning 4 SPACES 8 X.R
        ELSE ?.gon THEN ;

: .restHV ( snr )
	cr 32 spaces
	HV{ over } @  .gon
	dup RetningsKonst     4 SPACES ( f ) .gon  
	HVvekt{ swap } @ forventning ( cc>i ) .gon ;

: .sikt+kvalitet   ( -- )
   CR CR
   .overskriftPP 15 SPACES 
   ." obs         restfeil       forventa"
	AlleSikt DO
		CR  SFRA{ I } 16 TYPE   STIL{ I } 16 TYPE
		i siktdata
		HVvekt{ i } @ IF  i .restHV  THEN 
		LS{ i }     @ IF  i .restLS  THEN
	LOOP ;

