\ koordinatforbetring
\ Løysing av likningane
\ Koordinatbetring blir gjentatt inntil godtnok

VARIABLE SumvvForrige

: .feilkvsum ( n -- )   \ for testing av skalering
	DUP    1 CELLS 8 *  DUP ROT SWAP	\ bits/celle
	CR 2 BASE !   .R   					\ vis fyllingsgrad
	CR DECIMAL    .R ;					\ rå, med skalering

: .Endringar ( --  ) \ viser alle
	CR ." Elementforbetringar "
	etal2 @ 1 - 0 DO   X{ I } ?  LOOP ;
	
: MaxEndring ( -- max )
	0   etal2 @ 1 - 0 DO   X{ I } @   ABS MAX   LOOP ;
	
: ItResultat ( -- )
	sumpvvi @ .feilkvsum    \ oppskalert
	CR ." F.kv.sum " sumpvvi @
	-skaler -skaler .       \ nedskalert
	.Endringar ;

: Stabilt?   ( -- flag )  \ små korreksjonar
	MaxEndring 2 <   DUP IF  ." Elementforbetringar små nok. "   
	THEN ;

: Grovfeil?   ( -- flag )  \ 2 ulike avslutningsgrunna
	SumvvForrige @   sumpvvi @ <
	MaxEndring ( max )   20 >  AND
	DUP IF  CR  ." Store korr og f.kv.sum.-auke "  THEN
	;

: FKSAuke?   ( -- flag )  \ 2 ulike avslutningsgrunna
	SumvvForrige @   sumpvvi @ <   DUP IF  CR  ." Aukande f.kv.sum. "  THEN
	;
: FKSlik?   ( -- flag )  
	SumvvForrige @   sumpvvi @ =   DUP IF  CR  ." Stabil f.kv.sum. "  THEN
	;
	
: ForkastSiste
	." Pendling. Siste forkasta"
	SumvvForrige @   sumpvvi ! ;

: Overflyt?   ( -- flag )  \ ff større enn cellebreidd
	sumpvvi @ 0<
	DUP IF  CR  ." Overflyt "  THEN ;

: Kryssmultipliser ( -- ) \ dann normallikningar ved akkumulering 
	#ko 0 DO		\ #ko er dimensjonen på IN og FE
		#ko 0 DO
			IN{ I } @ 0< 0= IN{ J } @ 0< 0= AND IF
				FE{ I } @   FE{ J } @   *   Pvekt @ * krymping @ /
				N1{{ IN{ I } @   IN{ J } @  }}  +!
			THEN
		LOOP
	LOOP ;

: FyllNormallikningane ( -- )
	1 #obs +!
	Kryssmultipliser ;

